use crate::constants::*;
use crate::graphics::vga_color as vga;
use crate::resources::Resources;
use bracket_lib::prelude::*;

pub fn draw(resources: &mut Resources, bterm: &mut BTerm) {
    if let Some(flashing_message) = &mut resources.flashing_message {
        flashing_message.next_color();

        bterm.print_color_centered_at(
            MAP_X + (MAP_WIDTH / 2),
            MAP_Y + MAP_HEIGHT,
            RGB::named(vga::get_by_index(flashing_message.color)),
            RGB::named(vga::BLACK),
            flashing_message.message.to_string(),
        );
    }
}
